
Pre-Development - Feature #19065

FE - React - Fields dirty warning 

04 December 2023 02:39 PM - chok yee fan

Status: Closed Start date: 04 December 2023

Priority: Normal Due date:  

Assignee: chok yee fan % Done: 80%

Category:  Estimated time: 0.00 hour

Target version:  Spent time: 0.00 hour

Description

R&D if the user entered the fields, but navigate to other page or refresh browser, should prompt warning.

Either using react hook form or react router v6 to do the checking

History

#1 - 04 December 2023 05:05 PM - Amirul Umar Pandai

- Status changed from New to In Progress

#2 - 06 December 2023 11:41 AM - Amirul Umar Pandai

- % Done changed from 0 to 80

New component is implemented for warning prompt when both navigating and reloading with dirty fields, but due to the way onbeforeunload event is

enforced, custom UI cannot be implemented for reload event.

Reference:

1. https://developer.chrome.com/blog/chrome-51-deprecations/#remove_custom_messages_in_onbeforeunload_dialogs

2. https://stackoverflow.com/a/276739

As such, both navigating and reloading have to use separate UI to handle warning message. Organisation profile form page includes this component

as an example.

Will implement in the rest of the pages if this implementation would suffice.

#3 - 12 December 2023 01:33 PM - Amirul Umar Pandai

- Status changed from In Progress to Resolved

- Assignee changed from Amirul Umar Pandai to chok yee fan

prompt warning on dirty field (Organisation Profile form)

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/6753895da969259c081c4c96fb78aaf4dede0113

#4 - 14 December 2023 10:43 AM - chok yee fan

- File Screenshot 2023-12-14 at 10.34.24 AM.png added

- Status changed from Resolved to Feedback
- Assignee changed from chok yee fan to Amirul Umar Pandai

issue

-----

boostrap model alert.

expected

-----

use windows alert will do.

#5 - 15 December 2023 04:09 PM - Amirul Umar Pandai

- change Prompt component to hook, change modal to built-in window

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/13146c74d7bdac96f85599f5bcb0898705c55671

#6 - 15 December 2023 04:10 PM - Amirul Umar Pandai

- Assignee changed from Amirul Umar Pandai to chok yee fan

#7 - 18 December 2023 11:17 AM - chok yee fan

- Assignee changed from chok yee fan to Amirul Umar Pandai

- upgrade 6.21.0 change at package.json

- use useBlocker from the library

- create another file for usePrompt don't put it into the hooks.tsx file. the hooks particular for ngrx store

#8 - 19 December 2023 04:31 PM - Amirul Umar Pandai

- Assignee changed from Amirul Umar Pandai to chok yee fan

- fix org profile modify button does nothing

- move usePrompt hook to own file

- re-organise org profile + user role code

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/b3c05da00efe3b92cf2c23f8f4134dfdcd251bb2

#9 - 08 January 2024 02:47 PM - chok yee fan

- Assignee changed from chok yee fan to Amirul Umar Pandai

issue

-----

login -> navigate to org profile -> view org profile -> modify -> modify fields -> navigate to other link -> prompt -> click ok -> refresh the whole.

expected

-----

login -> navigate to org profile -> view org profile -> modify -> modify fields -> navigate to other link -> prompt -> click ok -> navigate to the page.
#10 - 09 January 2024 02:49 PM - Amirul Umar Pandai

- Assignee changed from Amirul Umar Pandai to chok yee fan

fix usePrompt refreshing page on navigate

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/abc36b609c091fe600f78f181ad04bd626eb8e5f

#11 - 16 January 2024 03:22 PM - chok yee fan

- Assignee changed from chok yee fan to Amirul Umar Pandai

as per discussion in the morning meeting.

How the behaviour between cancel popup and dirty field popup ? Does it conflict how it behave?

#12 - 23 January 2024 04:28 PM - Amirul Umar Pandai

- Assignee changed from Amirul Umar Pandai to chok yee fan

Applied double prompt fix to all pages. Also fixed another issue where when executing navigate(-1) during cancel form, will sometimes accidentally

prompt "Reload page?" window.

This conflicts with dirty field checking, where React Router library treats navigate(-1) as go back button for browser. This action, along with browser

refresh, triggers the onbeforeunload event, which in turn prompts the "Reload page?" window.

Going forward, when navigating away from page with dirty field checking, should instead be navigate(path_to_previous_page).

e.g. from UserProfileForm.tsx, navigate(-1) should instead be navigate("/userProfile/search")

- Prevent "Reload page?" prompt on cancel form to go back to previous page

- Prevent double prompt for cancelling and navigating to new page

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/31c84ca0476696b81bddd20df08accd01d8efa0b

#13 - 29 January 2024 11:40 AM - chok yee fan

- File Screenshot 2024-01-29 at 11.39.07 AM.png added

- Assignee changed from chok yee fan to Amirul Umar Pandai

careless

issue

---

page still using navigate(-1)

expected

---

page NOT using navigate(-1)
#14 - 29 January 2024 04:08 PM - chok yee fan

- File Screenshot 2024-01-29 at 4.07.53 PM.png added

issue

-----

modify the field -> click cctopnavbar menu -> popup alert and click cancel -> click cctopnavbar menu -> navgiate to other page.

expected

-----

modify the field -> click cctopnavbar menu -> popup alert and click cancel -> click cctopnavbar menu -> SHOULD popup alert

#15 - 02 February 2024 05:13 PM - Amirul Umar Pandai

- Status changed from Feedback to Resolved

- Assignee changed from Amirul Umar Pandai to Hazimi Muhammad

MLEB Core:

Change cc_topnavbar links to href

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-core/-/commit/973b62187d866b126b3954ff279e7c3b1b503f3e

MLEB IAM:

Persist popup on click topnavbar link after clicking "Cancel" more than once

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/be8c5c824ac968fa34f971672e977df442099466

#16 - 05 February 2024 03:09 PM - Hazimi Muhammad

- Status changed from Resolved to In Progress

- Assignee changed from Hazimi Muhammad to Amirul Umar Pandai

issue

-----

modify the field -> click cctopnavbar menu -> popup alert and click cancel -> click cctopnavbar menu -> navigate to other page.

expected

-----

modify the field -> click cctopnavbar menu -> popup alert and click cancel -> click cctopnavbar menu -> SHOULD popup alert

The issue are not solve yet. when i click the click cctopnavbar menu after cancel the popup alert, it still navigate to other page

#17 - 05 February 2024 05:30 PM - Amirul Umar Pandai

- Status changed from In Progress to Resolved
- Assignee changed from Amirul Umar Pandai to Hazimi Muhammad

Feature #19065 - revise usePrompt logic

https://dev.silverlakemobility.com/gitlab/mleb-solution-domain/smesd100/mleb-iam/-/commit/f2bd878b0677258ea6d90eeeeff58a90db49e9fd

#18 - 06 February 2024 10:23 AM - Hazimi Muhammad

- Status changed from Resolved to Feedback

- Assignee changed from Hazimi Muhammad to chok yee fan

Modify or add the field -> click cctopnavbar menu -> popup alert and click cancel -> click cctopnavbar menu -> popup alert is there

Already test for all module with same scenario and the result is same.

#19 - 28 February 2024 04:15 PM - chok yee fan

- Status changed from Feedback to Closed

working as expected

Files

Screenshot 2023-12-14 at 10.34.24 AM.png 112 KB 14 December 2023 chok yee fan

Screenshot 2024-01-29 at 11.39.07 AM.png 219 KB 29 January 2024 chok yee fan

Screenshot 2024-01-29 at 4.07.53 PM.png 571 KB 29 January 2024 chok yee fan
